$(function(){
  // Set a default value and apply it to all the slider value fields.
  var defaultValue = 0;
  $('.opmon-answer-slider-field').val(defaultValue);

  // Create a jQuery UI slider element for each question.
  $('.opmon-answer-slider').slider({
    min: -1,
    max: 1,
    step: 0.01,
    value: defaultValue,
    slide: function(event, ui) {
      var form = $($(this).closest('form')),
          sliderValueField = $($(this).closest('li').find('input[type="hidden"]'));

      // Change some interface text to instruct the user to save their changes.
      contentGroupUnsaved($(this).closest('.opmon-questions-wrapper'));

      // Update the slider's hidden value field.
      sliderValueField.val(ui.value);
    }
  });

  // Pass these functions an element with an 'opmon-questions-wrapper' class.
  function contentGroupSaved(contentGroupElement, message) {
    if (message == null) {
      message = 'Saved.';
    }
    var formResponse = $(contentGroupElement.find('.opmon-form-response'));
    formResponse.removeClass('opmon-form-response-unsaved');
    formResponse.addClass('opmon-form-response-saved');
    formResponse.html(message);
    var formButton = $(contentGroupElement.find('.opmon-form-submit'));
    formButton.hide();
  }
  function contentGroupUnsaved(contentGroupElement, message) {
    if (message == null) {
      message = 'Click "Save" to save your changes.';
    }
    var formResponse = $(contentGroupElement.find('.opmon-form-response'));
    formResponse.removeClass('opmon-form-response-saved');
    formResponse.addClass('opmon-form-response-unsaved');
    formResponse.html(message);
    var formButton = $(contentGroupElement.find('.opmon-form-submit'));
    formButton.show();
  }

  // Initialise the sliders.
  var sliderFields = $('.opmon-answer-slider-field');
  $.each(sliderFields, function(index, element){
    // See if there's a value already defined for this slider.
    var elementId = $(element).attr('id'),
        elementIdParts = elementId.split('-');
    if(opmonValues['c_' + elementIdParts[4]] && opmonValues['c_' + elementIdParts[4]]['q_' + elementIdParts[5]]) {
      var sliderValue = opmonValues['c_' + elementIdParts[4]]['q_' + elementIdParts[5]];
      $(this).val(sliderValue);
      $(this).parent().find('.opmon-answer-slider').slider('option', 'value', sliderValue);

      contentGroupSaved($(this).closest('.opmon-questions-wrapper'));
    }
    else {
      contentGroupUnsaved($(this).closest('.opmon-questions-wrapper'), '');
    }
  });

  // Handle a slider form submission.
  $('.opmon-form-submit').click(function(){
    var form = $($(this).closest('form')),
        answers = form.find('input[type="hidden"]'),
        data = '';

    // Collate the answers for this content's questions.
    $.each(answers, function(index, answer){
      data = data + (data != '' ? '&' : '') + $(answer).attr('id') + '=' + $(answer).val();
    });

    // Submit the answers to the handler.
    $.ajax({
      type: 'POST',
      url: Drupal.settings.basePath + 'opmon/submit',
      data: data,
      dataType: 'json',
      success: function(response){
        contentGroupSaved(form.closest('.opmon-questions-wrapper'));
      },
      error: function(){
        contentGroupUnsaved(form.closest('.opmon-questions-wrapper'), 'Couldn\'t save - please try again.');
      }
    });
  });

  // Initialise the user metrics form fields.
  var metricsFields = find('#opinion-monitor-prepare-frontend-metrics-form select[id^="opmon-metrics-input-"]');
  $(metricsFields).change(function(event){
    // Change some interface text to instruct the user to save their changes.
    contentGroupUnsaved($(event.target).closest('.opmon-questions-wrapper'));
  });

  // Handle a user metrics form submission.
  $('#opmon-metrics-submit').click(function(){
    var form = $('#opinion-monitor-prepare-frontend-metrics-form'),
        answers = form.find('select[id^="opmon-metrics-input-"]'),
        data = '';
    // Collate the answers for this content's questions.
    $.each(answers, function(index, answer){
      data = data + (data != '' ? '&' : '') + $(answer).attr('id') + '=' + $(answer).val();
    });
    // Submit the answers to the handler.
    $.ajax({
      type: 'POST',
      url: Drupal.settings.basePath + 'opmon/submit_metrics',
      data: data,
      dataType: 'json',
      success: function(response){
        contentGroupSaved(form.closest('.opmon-questions-wrapper'));
      },
      error: function(){
        contentGroupUnsaved(form.closest('.opmon-questions-wrapper'), 'Couldn\'t save - please try again.');
      }
    });
    // Abort the standard form submission.
    return false;
  });

  // Use jQuery to set the tabindex of the jQuery UI sliders, and all the other form elements, to the order they appear in the HTML.
  var tabIndexCounter = 0;
  $.each(
    $('a.ui-slider-handle, input.opmon-form-submit, input#opmon-metrics-submit, input#opmon-results-compare, select[id^="opmon-"]'),
    function(index, metric) {
      $(metric).attr('tabindex', tabIndexCounter++);
    }
  );
});
